#ifndef __ROBOT_MONET
#define __ROBOT_MONET

#include <Arduino.h>

#include <Servo.h>

/*classe robot
Cette classe le d'un robot
*/
enum e_cote{DROITE=1, GAUCHE};
enum e_sens{AVANT=1, ARRIERE};


class CParoi {
	public:
	CParoi(){m_angle=0; m_distance=0;};
	CParoi(const CParoi &sourceParoi) //constructeur de recopie
	{
		this->m_angle=sourceParoi.m_angle;
		this->m_distance=sourceParoi.m_distance;
	};
	 CParoi& operator=(const CParoi &sourceParoi) // opérateur d'affectation 
	 {
		this->m_angle=sourceParoi.m_angle;
		this->m_distance=sourceParoi.m_distance;
		return *this;
	 };
	 
  int m_angle;
  unsigned int m_distance;
};
class CTableau{
	public:
	CTableau(unsigned int nbelement)
	{
		m_nb_elements=nbelement;
		MesParoi = new CParoi [nbelement];
	};
	~CTableau()
	{
            delete [] MesParoi;	
	};
	void SetTab (unsigned int i, CParoi& lparoi)
	{
		if (i<m_nb_elements)
		{
			MesParoi[i]=lparoi;
		}
	};
	CParoi GetTab (unsigned int i)
	{

		return MesParoi[i];
	};

	unsigned int m_nb_elements;
	CParoi* MesParoi; 
};
class RobotMonet
{
public:
	

  RobotMonet(); //Constructeur
  Servo m_servo;  // create servo object to control a servo
  void Init( float entraxe, float diametre, float distance4s, byte vitesse_droit, byte vitesse_gauche );
  
  void VaToutDroit(); 				 //Déplacement en avant
  void VaEnArriere();				//Déplacement en arriere
  // void VaSens(e_sens le_sens){ switch (le_sens){ case AVANT:{VaToutDroit();} case ARRIERE:{VaEnArriere();} }};
   void VaSens(int le_sens){ switch (le_sens){ case 1:{VaToutDroit();break;} case 2:{VaEnArriere();break;} }};
   void VaToutDroit(unsigned int distance); 	//Déplacement en avant sur une distance définie
  unsigned long CalculTpsAvance(unsigned int distance); //
  
  void VaEnArriere(unsigned int distance); 	//Déplacement en avant sur une distance définie
  //void VaSens(e_sens le_sens,unsigned int distance){ switch (le_sens){ case AVANT:{VaToutDroit(distance);} case ARRIERE:{VaEnArriere(distance);} }};
  void VaSens(int le_sens,unsigned int distance){ switch (le_sens){ case 1:{VaToutDroit(distance);break;} case 2:{VaEnArriere(distance);break;} }};
  void TourneADroite(int);			//Tourne à droite suivant l'angle défini
  void TourneAGauche(int);			//Tourne à gauche suivant l'angle défini
  //void TourneCote(e_cote le_cote, int angle) { switch (le_cote){ case DROITE:{TourneADroite(angle);} case GAUCHE:{TourneAGauche(angle);} }};
  void TourneCote(int le_cote, int angle) { switch (le_cote){ case 1:{TourneADroite(angle);break;} case 2:{TourneAGauche(angle);break;} }};
  void TourneADroite();				//Tourne à droite 
  void TourneAGauche();				//Tourne à gauche 
  void TourneADroiteCourt();		//Tourne à droite 
  void TourneAGaucheCourt();		//Tourne à gauche 
  void TourneADroiteCourt(int);			//Tourne court à droite suivant l'angle défini
  void TourneAGaucheCourt(int);			//Tourne court à gauche suivant l'angle défini
 // void TourneCourtCote(e_cote le_cote, int angle) { switch (le_cote){ case DROITE:{TourneADroiteCourt(angle);} case GAUCHE:{TourneAGaucheCourt(angle);} }};
  void TourneCourtCote(int le_cote, int angle) { switch (le_cote){ case 1:{TourneADroiteCourt(angle);break;} case 2:{TourneAGaucheCourt(angle);break;} }};
  void VajusquaLigne();				//Avance jusqu'à la ligne
  bool VajusquaLigne(unsigned int); //Avance jusqu'à la ligne en se limitant à la distance prévu. renvoie true si il trouve une ligne
  void Tourne(int angle);			//Tourne le robot sur une roue (-90 à droite  0 droit devant, 90 à gauche)
  void TourneCourt(int angle);			//Tourne le robot sur deux roues (-90 à droite  0 droit devant, 90 à gauche)
  void Stop();						//Arrete le robot
  void Regarde(int angle); 			//-90 à droite  0 droit devant, 90 à gauche
  unsigned int CalculDistance();	//renvoie la distance en cm de la paroi
  unsigned int TrouveDistanceParoiPlusProche(unsigned int  distance_mini, int angle_mini, int angle_maxi); 	//renvoie la distance en cm de la paroi la plus proche
   unsigned int TrouveDistanceParoiPlusLoin(unsigned int distance_mini, int angle_mini, int angle_maxi);	//renvoie la distance en cm de la paroi la plus loin
   int TrouveAngleParoiPlusProche(unsigned int distance_mini, int angle_mini, int angle_maxi);	//renvoie l'angle en cm de la paroi la plus proche
   int TrouveAngleParoiPlusLoin(unsigned int distance_mini, int angle_mini, int angle_maxi); //renvoie l'angle en cm de la paroi la plus loin
  bool DetecteurDroitSurLigne();	//renvoie true si le capteur droit est sur la ligne
  bool DetecteurGaucheSurLigne();	//renvoie true si le capteur gauche est sur la ligne
 // bool DetecteurCoteSurLigne(e_cote le_cote) { switch (le_cote){ case DROITE:{DetecteurDroitSurLigne();} case GAUCHE:{DetecteurGaucheSurLigne();} }};
  bool DetecteurCoteSurLigne(int le_cote) { switch (le_cote){ case 1:{return DetecteurDroitSurLigne();break;} case 2:{return DetecteurGaucheSurLigne();break;} }};
  bool VaToutDroitJusquaLimite(unsigned int);		//va se positionner jusqu'a la limite + ou - la distance
  CParoi  TrouveParoiPlusProche(unsigned int  distance_mini, int angle_mini, int angle_maxi);		//fait un scan à 180° des paroi et renvoie une instance de "CParoi "

									//au dessus de distance_mini
	
	CParoi  TrouveParoiPlusLoin(unsigned int  distance_maxi, int angle_mini, int angle_maxi);		//fait un scan à 180° des paroi et renvoie une instance de "CParoi " 

									//au dessus de distance_mini
	
private:
	float ChercheAngleMoyen(CTableau& LeTab, unsigned int index );
	void Attache(); //définit les connexions.
	const int AIA = 3;  // (pwm) pin 3 connected to pin 1N1
	const int AIB = 5;  // (pwm) pin 5 connected to pin 1N2
	const int BIA = 11; // (pwm) pin 11 connected to pin 1N3
	const int BIB = 6;  // (pwm) pin 6 connected to pin 1N4
	const int SERV = 10; //servomoteur sur la patte 10
	const int TRIGPIN = 13;  //Trig Ultrasons (sortie)
	const int ECHOPIN = 12;  //Echo Ultrasons (entrée)
	const int CAPTEURDROIT = 2; 	//detecteur droit
	const int CAPTEURGAUCHE = 4;	//detecteur gauche
	const int LIGNE = 1;
	const int PAROI = 2;
	
	const int LIGNE_PAROI = 3;
	byte m_vitesse_droit;// = 175;  // change this (0-255) to control the speed of the motors
	byte m_vitesse_gauche;// = 200;  // change this (0-255) to control the speed of the motors
	float m_diametreRoue;// = 4.1;//Diametre en cm
	float m_entreAxe;// = 12.7; //m_entreAxe en cm
	float m_distance4Secondes;// = 114; // distance parcouru en 4 secondes
	const float pi = 3.1415926;
	float CalculVitesseN();
	unsigned long CalculTpsTourne(int angle); //calcul du temps pour une rotation de l'angle défini en argument
	float VitesseN;	
	const int m_Latence= 0;
	

};
#endif